#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "QHBoxLayout"
#include "QList"
#include "newmap.h"
#include "QMessageBox"
#include "qfiledialog.h"
#include "mappysaver.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    QHBoxLayout *l = new QHBoxLayout();
    l->addWidget(ui->tileset);
    ui->scrollArea->widget()->setLayout(l);

    l = new QHBoxLayout();
    l->addWidget(ui->maps);
    ui->scrollArea_2->widget()->setLayout(l);

    //Setting Size
    ui->tileset->setMaximumHeight(0);
    ui->tileset->setMinimumHeight(0);
    ui->tileset->setMaximumWidth(0);
    ui->tileset->setMinimumWidth(0);
    ui->maps->setMaximumHeight(0);
    ui->maps->setMinimumHeight(0);
    ui->maps->setMaximumWidth(0);
    ui->maps->setMinimumWidth(0);

    //Default Setting
    ui->tileset->setMinimumWidth(0);
    ui->tileset->setMinimumHeight(0);
    QList<int> sizes;
    sizes << 200 << 500;
    ui->splitter->setSizes(sizes);



}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_action_New_Map_triggered()
{
    NewMap *map = new NewMap();
    int result = map->exec();

    if(result == QDialog::Accepted)
    {
        ui->maps->blw = map->blw;
        ui->maps->blh = map->blh;

        //Apply new size
        ui->maps->setMinimumWidth(map->blw * 32);
        ui->maps->setMinimumHeight(map->blh * 32);
        ui->maps->setMaximumWidth(map->blw * 32);
        ui->maps->setMaximumHeight(map->blh * 32);

        //Creating map
        ui->maps->map = QPixmap(map->blw *32,map->blh *32);
        ui->maps->tileset = this->ui->tileset;


    }
}


void MainWindow::on_actionLoad_Tileset_triggered()
{
    QString filename = QFileDialog::getOpenFileName(this,
                                                        tr("Apri il file Tileset"),"",
                                                        tr("File PNG (*.png)"));

        if(filename.isEmpty())
        {
            return;
        }else
        {
           /* QPixmap tiles;
            tiles.load(filename);
            ui->tileset->setVisible(true);
            ui->tileset->setPixmap(tiles);
            ui->tileset->setMinimumWidth(tiles.width());
            ui->tileset->setMinimumHeight(tiles.height());*/
            ui->tileset->LoadTileset(filename);
        }
}


void MainWindow::on_actionSave_Map_triggered()
{

    QString filename = QFileDialog::getSaveFileName(this,
                                                    tr("Seleziona il file da salvare"),QString(),
                                            tr("File Mappa (*.mp2d)"));

    MappySaver::Tile t;
    MappySaver m;


    for(int i = 0; i < ui->maps->Tiles.count(); i++)
    {
        t.ID = ui->maps->Tiles[i].ID;
        t.h = ui->maps->Tiles[i].h;
        t.rect = ui->maps->Tiles[i].rect;
        t.w = ui->maps->Tiles[i].w;
        t.x = ui->maps->Tiles[i].x;
        t.y = ui->maps->Tiles[i].y;
        m.Tiles.append(t);
    }


        QFile f(filename);

         if(!f.open(QIODevice::WriteOnly))
         {

         }else
         {
             //Saving Map
             QDataStream out(&f);
             out.setVersion(QDataStream::Qt_4_8);
             out << m.Tiles;

             //Saving TIleset

         }

        f.flush();
        f.close();


}

void MainWindow::on_actionLoad_Map_triggered()
{
    QString filename = QFileDialog::getOpenFileName(this,
                                                    tr("Apri una mappa"),QString(),
                                                     tr("File Mappa (*.mp2d)"));

       QFile f(filename);

       MappySaver m;

     if(!f.open(QIODevice::ReadOnly))
     {

     }else
     {
         QDataStream in(&f);
         in.setVersion(QDataStream::Qt_4_8);
         in >> m.Tiles;
     }

    f.flush();
    f.close();


    mapeditor::Tile t;
    for(int i = 0; i < m.Tiles.count(); i++)
    {
        t.h = m.Tiles[i].h;
        t.ID = m.Tiles[i].ID;
        t.rect = m.Tiles[i].rect;
        t.w = m.Tiles[i].w;
        t.x = m.Tiles[i].x;
        t.y = m.Tiles[i].y;
        ui->maps->Tiles.append(t);
    }

}
