#include "character.h"
#include "qdebug.h"

Character::Character(QString filename, int TotalFrame)
{
    this->map = QPixmap(QString("data/Character/%1").arg(filename));

    Frame = TotalFrame;
    this->char_sizeW = map.width() / TotalFrame;
    this->char_sizeH = map.height() / 4;

    iFrame = 0;
}


void Character::MoveDown()
{
    iMoveY = 32;


}

void Character::MoveUp()
{
    iMoveY = -32;
}

void Character::MoveRight()
{
    iMoveX = 32;
}

void Character::MoveLeft()
{
    iMoveX = -32;
}


void Character::Draw(QPainter &p)
{
    //int sourceX = iFrame * char_sizeW;
   int sourceX = (iFrame / Frame) * char_sizeW;
    //rectSource.X = (m_iFrame / 4) * 64;
    //int sourceX = (iFrame + 1) %16;
    int sourceY = Direction * char_sizeH;

    p.drawPixmap(PositionX,PositionY,map,sourceX,sourceY,char_sizeW,char_sizeH);
}


void Character::Update()
{

    if(iMoveY != 0 || iMoveX != 0)
    {
        iFrame = (iFrame + 1) % (Frame * 4);
    }


    if(iMoveY > 0)
    {
        iMoveY-=2;
        PositionY+=2;
        Direction = 0;
    }

    if(iMoveY < 0)
    {
        iMoveY+=2;
        PositionY-=2;
        Direction = 3;

    }

    if(iMoveX > 0)
    {
        iMoveX-=2;
        PositionX+=2;
        Direction = 2;

    }

    if(iMoveX < 0)
    {
        iMoveX +=2;
        PositionX -=2;
        Direction = 1;

    }

}
