#ifndef RENDER_H
#define RENDER_H

#include <QtOpenGL/QGLWidget>
#include <QBrush>
#include <QFont>
#include <QImage>
#include <QPen>
#include <QTimer>
#include <stdlib.h>
#include <math.h>
#include <QPaintEvent>
#include <QMouseEvent>
#include <QtOpenGL>
#include <QPixmap>
#include "mappysaver.h"
#include "character.h"


class GLWidget : public QGLWidget
{
    Q_OBJECT

    int x = 100;
public:
    GLWidget(QWidget *parent = 0);
    QPixmap Tileset;
    MappySaver mappa;
    QString levelname = "mappa.mp2d";
    QPixmap logo;
    Character *Player;

    QPoint mPressLoc;
    int camX = width() /2 - Player->PositionX;
    int camY = height() /2 - Player->PositionY;
    Character *NPC00,*NPC01,*NPC02;


    ~GLWidget();

    void LoadTexture(QString filename);
    
protected:

    void initializeGL();
        void paintEvent(QPaintEvent *event);
        void resizeGL(int width, int height);
        void mousePressEvent(QMouseEvent *event);
        void mouseMoveEvent(QMouseEvent *event);
        void timerEvent(QTimerEvent *);
        void glInit();
        void keyPressEvent(QKeyEvent *e);

private:
        void setupViewport(int width, int height);
        int render_width = 800;
        int render_height = 600;



signals:
    
public slots:
    
};

#endif // RENDER_H
